# Define handlers for php
%define php /usr/bin/php-cgi
%define apr /usr/bin/apr-1-config
%if 0%{?fedora}
	%define handler php5-script
%endif
%if 0%{?rhel}
	%define handler x-httpd-php
%endif

%{!?_httpd_apxs: %{expand: %%global _httpd_apxs %%{_sbindir}/apxs}}
%{!?_httpd_mmn: %{expand: %%global _httpd_mmn %%(cat %{_includedir}/httpd/.mmn || echo 0-0)}}

Name: mod_suphp
Version: 0.7.2
Release: 0BX17%{?dist}
Summary: An apache2 module for executing PHP scripts with the permissions of their owners

Packager: Michael Stauber <mstauber@blueonyx.it>
Vendor: Team BlueOnyx, http://www.blueonyx.it/

License: GPLv2+
URL: http://www.suphp.org/
Source0: http://www.suphp.org/download/suphp-%{version}.tar.gz
Source1: suphp.conf
Source2: mod_suphp.module.conf
Patch0: mod_suphp-0.7.2-Apache24.patch

BuildRequires: make
BuildRequires:  gcc-c++
BuildRequires: httpd-devel >= 2.0, apr-devel, autoconf, libtool
Requires: httpd >= 2.0, %{php}
Requires: httpd-mmn = %{_httpd_mmn}


%description
suPHP is an Apache module for executing PHP scripts with the permissions of
their owners. It consists of an Apache module (mod_suphp) and a setuid root
binary (suphp) that is called by the Apache module to change the uid of the
process executing the PHP interpreter.

%prep
%setup -q -n suphp-%{version}
%patch0 -p 1 -b .ap24

cp -a %{SOURCE2} mod_suphp.module.conf

%{__cat} <<EOF >suphp.conf
[global]
logfile=%{_localstatedir}/log/httpd/suphp_log
loglevel=info
webserver_user=apache
docroot=/
env_path=/bin:/usr/bin
umask=0022
min_uid=501
min_gid=500

; Security options
allow_file_group_writeable=true   
allow_file_others_writeable=false
allow_directory_group_writeable=true
allow_directory_others_writeable=false

;Check wheter script is within DOCUMENT_ROOT
check_vhost_docroot=true

;Send minor error messages to browser
errors_to_browser=true

[handlers]
;Handler for php-scripts
x-httpd-suphp="php:/usr/bin/php-cgi"
x-httpd-suphp-5.6="php:/home/solarspeed/php-5.6/bin/php-cgi"
x-httpd-suphp-7.0="php:/home/solarspeed/php-7.0/bin/php-cgi"
x-httpd-suphp-7.1="php:/home/solarspeed/php-7.1/bin/php-cgi"
x-httpd-suphp-7.2="php:/home/solarspeed/php-7.2/bin/php-cgi"
x-httpd-suphp-7.3="php:/home/solarspeed/php-7.3/bin/php-cgi"
x-httpd-suphp-7.4="php:/home/solarspeed/php-7.4/bin/php-cgi"
x-httpd-suphp-7.5="php:/home/solarspeed/php-7.5/bin/php-cgi"
x-httpd-suphp-7.6="php:/home/solarspeed/php-7.6/bin/php-cgi"
x-httpd-suphp-7.7="php:/home/solarspeed/php-7.7/bin/php-cgi"
x-httpd-suphp-7.8="php:/home/solarspeed/php-7.8/bin/php-cgi"
x-httpd-suphp-7.9="php:/home/solarspeed/php-7.9/bin/php-cgi"
x-httpd-suphp-8.0="php:/home/solarspeed/php-8.0/bin/php-cgi"
x-httpd-suphp-8.1="php:/home/solarspeed/php-8.1/bin/php-cgi"
x-httpd-suphp-8.2="php:/home/solarspeed/php-8.2/bin/php-cgi"
x-httpd-suphp-8.3="php:/home/solarspeed/php-8.3/bin/php-cgi"
x-httpd-suphp-8.3="php:/home/solarspeed/php-8.4/bin/php-cgi"

;Handler for CGI-scripts
x-suphp-cgi="execute:!self"

EOF

%{__cat} <<EOF >suphp.httpd
# This is the Apache server configuration file providing suPHP support.
# It contains the configuration directives to instruct the server how to
# serve php pages while switching to the user context before rendering.

LoadModule suphp_module modules/mod_suphp.so

# This option tells mod_suphp if a PHP-script requested on this server (or
# VirtualHost) should be run with the PHP-interpreter or returned to the
# browser "as it is".
suPHP_Engine off

# Disable php when suphp is used, to avoid having both.
#<IfModule mod_php5.c>
#php_admin_flag engine off
#</IfModule>
#<IfModule mod_php4.c>
#php_admin_flag engine off
#</IfModule>

# To use suPHP to parse PHP-Files
#AddHandler x-httpd-php .php
#AddHandler x-httpd-php .php .php4 .php3 .phtml

#suPHP_AddHandler x-httpd-php
#suPHP_UserGroup apache apache

# This option tells mod_suphp which path to pass on to the PHP-interpreter
# (by setting the PHPRC environment variable).
# Do *NOT* refer to a file but to the directory the file resides in.
#
# E.g.: If you want to use "/path/to/server/config/php.ini", use "suPHP_Config
# /path/to/server/config".
#
# If you don't use this option, PHP will use its compiled in default path.
# suPHP_ConfigPath /etc

# If you compiled suphp with setid-mode "force" or "paranoid", you can
# specify the user- and groupname to run PHP-scripts with.
# Example: suPHP_UserGroup foouser bargroup
# suPHP_UserGroup apache apache

# This option tells mod_suphp to handle requests with the type <mime-type>.
# Please note this only works, if an action for the handler is specified
# in the suPHP configuration file.
# suPHP_AddHandler x-httpd-php

# This option tells mod_suphp to NOT handle requests with the type <mime-type>.
# suPHP_RemoveHandler <mime-type>
EOF

%build
export CXXFLAGS="-std=c++14 $RPM_OPT_FLAGS"
aclocal
libtoolize --force
automake --add-missing
autoreconf

echo "Building mod_suphp with %{php} as PHP interpreter and %{apr} for the apr configuration script."
echo "%{handler} is used as a AddHandler."
%configure \
	--with-apr=%{apr} \
	--with-apxs=%{_httpd_apxs} \
	--with-apache-user=apache \
	--with-min-uid=501 \
	--with-min-gid=500 \
	--with-logfile=/var/log/httpd/suphp_log \
	--with-setid-mode=paranoid 

pushd src
make %{?_smp_mflags} suphp
popd

pushd src/apache2
%{_httpd_apxs} -c mod_suphp.c
mv .libs/mod_suphp.so .
popd


%install
rm -rf %{buildroot}
%{__install} -c -m 4755 -D src/suphp %{buildroot}%{_sbindir}/suphp
%{__install} -m 755 -D src/apache2/mod_suphp.so %{buildroot}%{_libdir}/httpd/modules/mod_suphp.so

# Install the config files
#%{__install} -m 644 -D mod_suphp.module.conf %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/02-mod_suphp.conf
%{__install} -Dp -m0644 suphp.conf %{buildroot}%{_sysconfdir}/suphp.conf
%{__install} -Dp -m0644 suphp.httpd %{buildroot}%{_sysconfdir}/httpd/conf.d/suphp.conf

# Rename docs
cp doc/CONFIG CONFIG.suphp
cp doc/apache/CONFIG CONFIG.apache



%files
%doc README COPYING CONFIG.suphp CONFIG.apache
%attr (4550, root, apache) %{_sbindir}/suphp
%{_libdir}/httpd/modules/*.so
%config(noreplace) %{_sysconfdir}/suphp.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/suphp.conf
#%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/02-mod_suphp.conf

%changelog

* Sun Dec 19 2021 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX17
- Build for 5211R on RHEL9.
- Based on mod_suphp-0.7.2-16.fc35.src.rpm with our changes merged in

* Fri Nov 16 2018 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX16
- Build for 5210R on RHEL8. Added 'libtoolize --force'

* Tue Mar 10 2015 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX15
- Updated version with support for multiple PHP versions.

* Wed Jan 28 2015 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX14
- Rebuild with different flags.

* Wed Jan 28 2015 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX13
- Totally revised config for 5209R on EL7.

* Wed Jul 16 2014 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX12
- Applied patch to allow build against Apache 2.4.
- Tweaked build options to allow compile to finish.
- See: https://lists.marsching.com/pipermail/suphp/2013-May/002553.html

* Thu Aug 30 2012 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX11
- Extended suphp-0.7.1/src/Application.cpp error message with notice about 'Web Ownership'.

* Sun Jul 24 2011 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX10
- Config norplace makes it necessary to run a search and replace on /etc/suphp.conf as well.

* Sun Jul 24 2011 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX09
- Changed umask in /etc/suphp.conf from 077 to 022.

* Mon Jul 05 2010 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX08
- Added logrotate for suPHP
- PHP session directory needs to be world writeable if we run php-cgi

* Sun Jul 04 2010 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX07
- Removed handler for an optional third party PHP
- Was a stupid idea as it would need changes in three different modules.
- Third party PHP installs must instead modify /etc/suphp.conf instead, which is much easier.

* Sun Jul 04 2010 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX06
- Added handler for an optional third party PHP
- This is necessary as suPHP will otherwise always use the onboard PHP

* Sun Jul 04 2010 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX05
- Changed 'errors_to_browser' to 'true' in /etc/suphp.conf
- While this may lead to an information disclosure, it also makes sure that site and server admins see why their site doesn't run anymore.
- So this is - for now - an acceptable drawback.

* Sat Jul 03 2010 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX04
- Apache restart added to post-install and post-uninstall

* Sat Jul 03 2010 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX03
- More tweaks:
- Minimum user ID is now 501, so that scripts owned by 'admin' are not executed for security reasons.
- Since suPHP-0.7.0 handler definitions in /etc/suphp.conf must be escaped with double-ticks
- We use /usr/bin/php-cgi as handler for PHP if suPHP is enabled
- Switched from paranoid to owner and use --enable-SUPHP_USE_USERGROUP=yes as well
- Commented out all unneeded definitions from /etc/httpd/conf.d/suphp.conf as we use all relevant options in the VHost containers

* Sat Jul 03 2010 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX02
- General option tweaking

* Sat Jul 03 2010 Michael Stauber <mstauber@blueonyx.it> 0.7.2-0BX01
- Updated to release 0.7.1

